/*;  list.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl list.h\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */
/*;  $$RCShost$$  */

// @(#) list.h -- single direction linear list

#if !defined(list_h)
#define list_h

#include <stdio.h>

#include "common.h"		//; ץˤ붦


class List;		//; 饹 Node ΤԴ

//;	ؿ Clear_function .

////////////////////////////////////////////////////////////////////////
// <japanese>
// 饹 List μϿ֥ȾõѴؿη Clear_function 
//
// ҡפ˳ݤ Node  delete , Node::object ؤμ
// õ뤿ޤ. (List::List )
// </japanese>
typedef void (*Clear_function)(void* obj);
	/* <japanese>
		Clear_function		饹 List μϿ֥ȾõѴؿη

	ҡפ˳ݤ Node  delete , Node::object ؤμ
	õ뤿ޤ. (List::List )

	ARGUMENT:
		obj	õ륪֥ȤؤΥݥ󥿤 void* ˥㥹Ȥ
				.
    </japanese>
	*/

inline void Clf_c(void* obj) { delete ((char*) obj); }
inline void Clf_i(void* obj) { delete ((int*) obj); }
inline void Clf_s(void* obj) { delete ((short*) obj); }
inline void Clf_l(void* obj) { delete ((long*) obj); }
inline void Clf_f(void* obj) { delete ((float*) obj); }
inline void Clf_d(void* obj) { delete ((double*) obj); }
inline void Clf_ld(void* obj) { delete ((long double*) obj); }
inline void Clf_uc(void* obj) { delete ((unsigned char*) obj); }
inline void Clf_ui(void* obj) { delete ((unsigned int*) obj); }
inline void Clf_us(void* obj) { delete ((unsigned short*) obj); }
inline void Clf_ul(void* obj) { delete ((unsigned long*) obj); }
inline void Clf_c_array(void* obj) { delete [] ((char*) obj); }
inline void Clf_i_array(void* obj) { delete [] ((int*) obj); }
inline void Clf_s_array(void* obj) { delete [] ((short*) obj); }
inline void Clf_l_array(void* obj) { delete [] ((long*) obj); }
inline void Clf_f_array(void* obj) { delete [] ((float*) obj); }
inline void Clf_d_array(void* obj) { delete [] ((double*) obj); }
inline void Clf_ld_array(void* obj) { delete [] ((long double*) obj); }
inline void Clf_uc_array(void* obj) { delete [] ((unsigned char*) obj); }
inline void Clf_ui_array(void* obj) { delete [] ((unsigned int*) obj); }
inline void Clf_us_array(void* obj) { delete [] ((unsigned short*) obj); }
inline void Clf_ul_array(void* obj) { delete [] ((unsigned long*) obj); }
	/* <japanese>
		Clf_c (inline)		char ѿ Clear_function ؿ.
		Clf_str (inline)	char ѿ Clear_function ؿ.
		Clf_i (inline)		int ѿ Clear_function ؿ.
		Clf_s (inline)		short ѿ Clear_function ؿ.
		Clf_l (inline)		long ѿ Clear_function ؿ.
		Clf_f (inline)		float ѿ Clear_function ؿ.
		Clf_d (inline)		double ѿ Clear_function ؿ.
		Clf_ld (inline)		long double ѿ Clear_function ؿ.
		Clf_uc (inline)		unsigned char ѿ Clear_function ؿ.
		Clf_ui (inline)		unsigned int ѿ Clear_function ؿ.
		Clf_ui (inline)		unsigned short ѿ Clear_function ؿ.
		Clf_ul (inline)		unsigned long ѿ Clear_function ؿ.

	áܡܤδܥǡб Clear_function ؿޤ.
    </japanese>
	*/

//	饹 List .

/*----------------------------------------------------------------------
CLASS
    List

DESCRIPTION
    <japanese>
    <pre>
	饹ꥹȤ,
		ϿΡɿ		: number
		ƬΡ		: head
		Ρ		: tail
		ꥹȾõѴؿ	: clear_function
	򵭲,
		֥ȤμϿǽ
		֥Ȥμǽ
		Ͽ֥, Ρɤξõǽ
		Ͽ֥ȵκǽ
	ޤ.

	ꥹȤϢ³, Ρɥǥ, 饹 Node ˤ¸Ƥޤ.
	ꥹȤˤ, ֥ȤؤΥݥ󥿤 void* ˥㥹ȤΤ
	Ͽޤ.
    </pre>
    </japanese>

----------------------------------------------------------------------*/

class List {

    //;	饹 Node .

    class Node {
    	/* <japanese>
    		Node	ñꥹȤΥΡɥǥΥ饹

    	饹 Node ,
    		ΥΡɤΥݥ			: next
    		Ͽ֥ȤΥݥ	: object
    	򵭲, ñꥹȤΥΡɤϢ³¸ޤ.
    	</japanese> */

    friend class List;
    	//; 饹 Node ǤΤ, 饹 List ΤߤǤ.

    private:
    	Node* next;		//; ϢʤΡɤؤΥݥ
    	void* object;	//; Ͽ֥ȤؤΥݥ

    	Node(void) : next(NULL), object(NULL) {}
    	virtual ~Node(void) {}
    		/* <japanese>
    			Node::Node  (inline)	󥹥ȥ饯
    		</japanese> */
    };

//;	0.	ǡ, ؿ.
protected:
  //////////////////////////////////////////////////////////////////////
  int		number;		//; Ρݥɿ

  //////////////////////////////////////////////////////////////////////
  Node*	head;		//; ƬΡɤؤΥݥ

  //////////////////////////////////////////////////////////////////////
  Node*	tail;		//; ΡɤؤΥݥ

  //////////////////////////////////////////////////////////////////////
  Node*	current;	//; ѥݥ

  //////////////////////////////////////////////////////////////////////
  Clear_function clear_function;	//; Ͽ֥ȾõѴؿ
		//; Ρɾõ Node::object ؤϿ֥ȤμΤõ
		//; ؿؤΥݥ
public:
  //////////////////////////////////////////////////////////////////////
  int Number(void) { return number; }

  //////////////////////////////////////////////////////////////////////
  void* Head(void) { return (head != NULL) ? head->object : NULL; }

  //////////////////////////////////////////////////////////////////////
  void* Tail(void) { return (tail != NULL) ? tail->object : NULL; }
		/* <japanese>
			List::Number(void) (inline)		number ֤
			List::Head(void) (inline)		head->object ֤
			List::Tail(void) (inline)		tail->object ֤
		</japanese> */

//;	1.	ꥹȤؤΥݥ󥿤μϿǽ, ꥹȤΥݥ󥿤μǽ.
public:
  //////////////////////////////////////////////////////////////////////
  void Put_head(void* obj);

  //////////////////////////////////////////////////////////////////////
  void Put_tail(void* obj);
		/* <japanese>
			List::Put_head(void*)	ꥹƬؤμϿ
			List::Put_tail(void*)	ꥹؤμϿ

		Ͽ֥ȤؤΥݥ󥿤 void* ˥㥹Ȥ, 
		obj ϤƲ.

		obj ؤΥ֥ȤμΤ򥳥ԡƼϿΤǤϤʤ
		 obj λؤεΰ, List ¦ǳ, Ʋ.

		ñꥹȤΤ List::Put_tail  List::Put_head ٺȤ
		٤ʤޤ.

		ARGUMENT:
			obj	ꥹȤƬ, ɲä륪֥ȤΥɥ쥹
					void* ˥㥹Ȥ.
		EXIT:
			5		obj Ǽ Node εΰݤǤʤ.
		</japanese> */
  //////////////////////////////////////////////////////////////////////
  void* Get_head(void);

  //////////////////////////////////////////////////////////////////////
  void* Get_tail(void);
		/* <japanese>
			List::Get_head(void)	ꥹƬμϿݥ󥿤μ
			List::Get_tail(void)	ꥹμϿݥ󥿤μ

		ƬޤΥΡɤ˳ǼƤϿ֥ȤؤΥݥ
		֤, ΥΡɤꥹȤ, õޤ.

		List::Get_tail  for 롼פޤि List::Get_head 
		٤ʤޤ.

		RETURN:
			void*		void* ˥㥹Ȥ줿Ͽ֥ȤΥɥ
						.
						ꥹȤ "" λ NULL ֤.
		</japanese> */

//;	2.	ꥹȤθǽ.
public:
  //////////////////////////////////////////////////////////////////////
  void Top(void) { current = head; }

  //////////////////////////////////////////////////////////////////////
  Boolean Look(void*& buffer);
		/* <japanese>
			List::Top(void) (inline)		ꥹȸΤν
			List::Look(void*&) (inline)		ꥹȤθ

		ꥹȤƬޤǽ֤˸, List::Top ˤ
		, ͤ NO ˤʤޤ List::Look 򷫤֤ѤƲ
		.

		buffer ˤɬ void* ѿϤƲ.
		㤨, void* ʳѿ void* ˥㥹Ȥ buffer Ϥ
		, Ϥλǥݥ󥿾󤬷ޤ.

		ARGUMENT:
			buffer	Ͽ֥ȤؤΥݥ󥿤Ǽ뻲Ȱ.
						ꥹޤǸѤߤξ, NULL Ǽ.
		RETURN:
			YES		buffer ˿ΡɤǼ줿.
			NO		˥ꥹȤޤǸλƤ.
		</japanese> */

//;	3.	ꥹȤξõǽ.
public:
  //////////////////////////////////////////////////////////////////////
  void Clear_node(void);

  //////////////////////////////////////////////////////////////////////
  void Clear(void);
		/* <japanese>
			List::Clear_node(void)	ΡɾõѴؿ
			List::Clear(void)		ꥹȾõѴؿ

		List::Clear_node , ꥹȤϢΥΡɤõޤ.

		List::Clear , ϢΥΡɤξõ˼Ͽ֥ȤμΤ⤢
		碌ƾõޤ. ˤ, ꥹȤξõ˼Ͽ֥Ȥ
		Τõ˺뤳Ȥɻߤޤ.

		, Ͽ֥ȤξõˡϼϿ֥Ȥηˤۤ
		Τ, ꥹȤФϿ֥ȤξõˡꤷƤɬפ
		ޤ.

		ꥹȤѼԤϰʲμ˽äƲ.

			֥ȤؤΥݥ󥿤 void* ˥㥹ȤΤ
			  ȤƼ, ΰݥ󥿤ؤΥ֥Ȥ
			  ؿ Clear_function  (list.h ) Ȥ
			  .
			Τ褦˺ؿؤΥݥ󥿤ꥹȤ˥
			  ȥ饯ΰϤ, Element::Set_clear_function ΰ
			  Ϥ.

		㤨, new ǳݤ int ֥Ȥ List ֥Ȥ
		Ͽ Clear_function ؿ,
			void Clf_i(void* obj) { delete ((int*) obj); }
		ѤߤǤ. List ֥,
			List int_list(Clf_i);
		Ȥ, int_list ξõõ, Ͽ֥ȤƼ
		ưŪ delete ޤ.

		, ξ clear_function ꤷʤǲ.
			ꥹȾõ˼Ͽ֥ȤμΤõʤ
			ꥹȤ˥쥸ΰΥǡϿƤ

		ARGUMENT:
			cl_func	Ͽ֥ȾõѴؿؤΥݥ.
						ǥեͤ NULL.
			flag		clear_function ֺѤߤλ, cl_func ѹ
						ݤΥե饰.
						YES ʤѹ, NO ʤѹʤ.
						ǥե NO.
		</japanese> */

//;	4. ꥹȤ󲽵ǽ.
public:
  //////////////////////////////////////////////////////////////////////
  void Make_array(void**& array, int& size);

  //////////////////////////////////////////////////////////////////////
  void List_to_array(void**& array, int& size)
		{ Make_array(array, size); Clear_node(); }
		/* <japanese>
			List::Make_array(void**&,int&)		κ
			List::List_to_array(void**&,int&)	ؤž

		Ͽ֥ȤؤΥݥ󥿤, ҡפ˳ݤ˳Ǽޤ.
		ꥹƬμϿݥ󥿤, Ƭ˳Ǽޤ.
		Make_array ǤñǤ, List_to_array Ǥ
		, ϢΥΡɤƾõޤ.

		array ˤϺؤΥݥ󥿤, size ˤǿǼ
		ޤ.
		ꥹȤ "" ξ, array ˤ NULL, size ˤ 0 Ǽޤ.

		εΰݤǤʤϥ顼åɽ, 
		 5  exit ޤ.

		array ˤɬ void** ѿϤƲ.
		㤨, void** ʳѿ void** ˥㥹Ȥ array 
		, Ϥλǥݥ󥿾󤬷ޤ.

		ARGUMENT:
			array		ؤΥݥ󥿤Ǽ뻲Ȱ.
						ꥹȤ "" ξ NULL Ǽ.
			size		array ǿǼ뻲Ȱ.
						ꥹȤ "" ξ 0 Ǽ.
		EXIT:
			5			εΰݤǤʤ.
		</japanese> */

//;	5.	ؿ, 󥹥ȥ饯, ǥȥ饯.
public:
  //////////////////////////////////////////////////////////////////////
  void Init(Clear_function cl_func);
		/* <japanese>
			List::Init(Clear_function)	ؿ

		clear_function  clear_function  cl_func ꤷޤ.
		, clear_function ꤵƤȤ, 顼å
		ϸ, return ޤ.

		ǥեȥ󥹥ȥ饯֥ȤνѤޤ.

		ARGUMENT:
			cl_func	Ͽ֥ȾõѴؿؤΥݥ.
		</japanese> */
public:
  //////////////////////////////////////////////////////////////////////
  List(Clear_function cl_func);

  //////////////////////////////////////////////////////////////////////
  List(void);

  //////////////////////////////////////////////////////////////////////
  virtual ~List(void);
		/* <japanese>
			List::List(Clear_function)		󥹥ȥ饯
			List::List(void)				󥹥ȥ饯
			List::~List(void) (virtual)		ǥȥ饯

		List(Clear_function) Ǥ, Init Ѥ, Фʲ̤
		ޤ.
			clear_function	: cl_func
			number			: 0
			head				: NULL
			tail				: NULL
			current			: NULL

		List(void) Ǥ, Init Ѥޤ. ΤʲȤʤޤ.
			clear_function	: NULL
		¾ΥФ, List(Clear_function) ƱǤ.
		ξ, Init Ѥ clear_function Ǥޤ.

		ǥȥ饯Ǥ, Clear ¹Ԥޤ.
		饹η˱ǥȥ饯ŬѤ褦˲ۥǥȥ
		Ȥޤ.

		clear_function  NULL ξ, Clear  Clear_node ¹Ԥޤ.
		ä, ~List  Clear_node ¹Ԥޤ.
		λ Node::object ؤΤ˵Ƥ륪֥Ȥμ
		Ͼõޤ.
		Ͽ֥ȤεΰϥꥹȤѼԤƲ.

		㤨, new ǳݤ֥Ȥ List ˼Ͽ,
			List õ, Ͽ֥ȤõƤ.
			Ͽ֥ȤΥɥ쥹 List ʳ˵Ƥ, List
			  õ, õ.
		Τɤ餫ԤɬפǤ礦.

		, ξ clear_object ꤷʤǲ.
			ꥹȾõ˼Ͽ֥ȤμΤõʤ
			ꥹȤ˥쥸ΰΥǡϿƤ

		ARGUMENT:
			cl_func	Ͽ֥ȾõѴؿؤΥݥ.
		</japanese> */

};


//;	饹 List Υ饤ؿμ.

inline Boolean List::Look(void*& buffer)
{	//;		List::Look(void*&) (define)

	if (current == NULL) { buffer = NULL; return NO; }
		//; tail ޤǸѤ.

	buffer = current->object; current = current->next; return YES;
}


#endif	// ! list_h

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
