/* osd_tmp.h {\documentstyle{jsrc2latex}\rhead{\sl osd\_tmp.h\quad\thepage}
   \font\tenrm=cmtt10}
{\ \begin{verbatim}
$RCSfile: osd_tmp.h,v $  $Revision: 1.2 $
$Date: 1996/01/06 02:47:34 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

This header file defines class OHyMoS_ReceiveStepData<T>. class
OHyMoS_ReceiveStepData<T> expresses a receive port which receives
step-formed data.

In step-formed data, the value is taken as constant and equal to the
current data value from the previous data time till the current data
time.

}% end of latex-mode }
*/

#if !defined(osd_tmp_h)
#define osd_tmp_h

#include "p_tmp.h"		// definition of the Data_pack class

//	Definition of template class OHyMoS_ReceiveStepData<T>

template <class T>
class OHyMoS_ReceiveStepData : public Receive<T> {
	/*
	  Class OHyMoS_ReceiveStepData<T> models a receive port which
	  receives step-formed data.

	  OHyMoS_ReceiveStepData<T> receives data of type Data<T> and takes
	  those  data as step-formed data.

	  OHyMoS_ReceiveStepData<T> can be connected with Send<T>, Relay<T>,
	  I_file<T>.

	*/

//	* Functions for getting datapacks
public:
	virtual T Get_data(time_t t);

		/*
		  OHyMoS_ReceiveStepData<T>::Get_data(time_t);

		  Returns the data value at time t.

		*/

    virtual T Get_data_sum(time_t t1, time_t t2);
		/*
		  OHyMoS_ReceiveStepData<T>::Get_data_sum(time_t t1, time_t t2)

          Returns the integrated value from time t1 till time t2.
		  t1 should be less than or equal to t2.

        */


//	* constructor and destructor
public:
	Boolean Init(char* p_name, int p_num)
		{ return Receive<T>::Init(p_name, p_num); }
	OHyMoS_ReceiveStepData(char* p_name, int p_num)
		:	Receive<T>(p_name, p_num)
		{ class_name = "OHyMoS_ReceiveStepData"; }
	OHyMoS_ReceiveStepData(void)
		:	Receive<T>()
		{ class_name = "OHyMoS_ReceiveStepData"; }
	~OHyMoS_ReceiveStepData(void) {}
		/*
		  OHyMoS_ReceiveStepData<T>::Init(char* p_name, int p_num)
		  OHyMoS_ReceiveStepData<T>::OHyMoS_ReceiveStepData(char*
		  p_name, int p_num)
		  OHyMoS_ReceiveStepData<T>::OHyMoS_ReceiveStepData(void)

		  For function Init, the init funcion of base class Receive<T>
		  is used.

		  The constructor with arguments initilizes the data members as

			class_name		: "OHyMoS_ReceiveStepData"
			object_name		: p_name
			object_number		: p_num
			owner				: NULL
			sender			: NULL

		  The constructor without arguments initializes the data members
		  as

			class_name		: "OHyMoS_ReceiveStepData"
			object_name		: NULL
			object_number		: -1
			owner				: NULL
			sender			: NULL

		  Objects which are created by the constructor without arguments
		  should be initialized afterwards by using the member funcition
		  Init.

		  ARGUMENT:
			p_name	object name (the name of the port)
			p_num		object number (port number)
		*/

};

#endif

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.2 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
