/*;  send.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl send.h\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */
/*;  $$RCShost$$  */

// @(#)  send.h -- abstract base class Send_port

/*
{\ {\setlength{\parskip}{4pt}% latex-mode

ܷüҥǥ \verb|Send_port| Ƥޤܷüҥ
ǥ, 貾۴ؿޤǤݥ饹Ǥ

}% end of latex-mode }
*/

#if !defined(send_h)
#define send_h

#include <stdio.h>
#include <time.h>			//; time_t , tm 

#include "common.h"			//; ץˤ붦
#include "list.h"			//; 饹 List 
#include "datapack.h"		//; 饹 Data_pack 
#include "sender.h"			//; 饹 Sender_port 
#include "element.h"        //; Definition of class Element

//;	饹 Send_port .

/*----------------------------------------------------------------------
CLASS

    Send_port

    Abstract class for creating send ports.

DESCRIPTION
    Abstract class for creating send ports.

    Data members data_pack_array and number_of_data_packs and some
    member functios to store datapacks are defined.

    <japanese>
    ܷüҥǥ \verb|Send_port| Ƥޤܷü
    ҥǥ, 貾۴ؿޤǤݥ饹Ǥ

    <pre>
	饹 Send_port Ǥ,
		ǡѥå	: data_pack_array, number_of_data_packs
	򵭲,
		ǡѥåϿ, ǽ
	ޤ.

	Send_port ǽ, 쥯饹 Sender_port ѤߤǤ.
	Send_port ˤ, ʣüҤ³Ǥޤ.
    </pre>
    </japanese>

----------------------------------------------------------------------*/

class Send_port : public Sender_port {

//;	0.	ǡ.
protected:
  //////////////////////////////////////////////////////////////////////
  // Pointer to an array of casted as void* of address of datapacks
  //
  // <japanese>
  // data_pack_array ؤˤ, void* ˥㥹Ȥ줿Ͽǡ
  // ѥåΥɥ쥹Ǽޤ.
  // </japanese>
  void**	data_pack_array;			//; ǡѥå

  //////////////////////////////////////////////////////////////////////
  // The number of elements stored in 'data_pack_array'
  int number_of_data_packs;		//; data_pack_array ǿ

  //////////////////////////////////////////////////////////////////////
  // protect_past_data_flag is designed to use to control the
  // protect mode of past data_pack\'s. protect_past_data_flag
  // should be checked in the functions Reduce_data_pack_stock and
  // Forget_data_pack_stock.
  Boolean protect_past_data_flag;


		/* <japanese>
		Sender_port::buffer_list , ³üҤϿȤ,
		׻ǡѥåμϿȤѤޤ.
        </japanese>
		*/

//;	1.	³ǽ.
public:
  //////////////////////////////////////////////////////////////////////
  // Returns the string which shows the type of the datapack sent by the
  // current port
  //
  // <japanese>
  // ǡѥåɽʸ֤쥯饹 Sender_port ν
  // ۴ؿǤ.  Send_port Ǥ貾۴ؿȤƤޤ.  Send_port
  // 饹, ǡѥåɽʸؤΥݥ󥿤֤
  // ɬƲ.
  //
  // 㤨, ǡѥå "INT" Ǥ饹Ǥ,
  // <pre>
  //    char* Data_pack_type(void) { return "INT"; }
  // </pre>
  // Τ褦ޤ.
  //
  // ³ˤ, üҤüҤȤ Data_pack_type פ뤳
  // Ȥǧޤ.
  //
  // <pre>
  //      RETURN:
  //          char*     ǡѥåɽʸؤΥݥ.
  // </pre>
  // </japanese>
  virtual char* Data_pack_type(void) = NULL;

public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  //
  // buffer_list üϿѤǡѥåϿѤž
  // ޤ.
  //
  // ޤ Sender_port::Switch ¹Ԥޤ.
  // ͤ NO ʤ, NO ֤ޤ.
  //
  // ͤ YES ʤ, List ֥Ȥ new Ǻ buffer_list
  // ꤷ, data_pack_array, number_of_data_packs  NULL, 0 
  // , YES ֤ޤ.
  //
  // λ, List::List ˤ, Clf_dp (datapack.h ) Ϥޤ.
  // ǵΰݤǤʤ, ٥룵Ƕλޤ.
  //
  // <pre>
  //    RETURN:
  //        YES   Send_port žǤ.
  //        NO    receive_port_array Ѥߤξ.
  //                (Sender_port::Switch)
  //                data_pack_array Ѥߤξ.
  //    EXIT:
  //        5     receive_port_array εΰݤǤʤä.
  //                (Sender_port::Switch)
  //                ǡѥåϿ buffer_list ҡפ˳ݤǤʤ
  //                ä. (new)
  // <pre>
  // </japanese>
  virtual Boolean Switch(void);

public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ׻γǧ
  //
  // 쥯饹 Sender_port β۴ؿǤ.
  //
  // ǡѥåǽʾ֤Ǥ뤳Ȥǧޤ.
  // receivers_array Ѥߤ, ǡѥåϿѤ buffer_list 
  // ¸ߤ, ǡѥåϿ, Ǥޤ.
  //
  // <pre>
  //    RETURN:
  //        YES   sender  NULL , ǡѥåϿ buffer_list 
  //                ¸ߤ.
  //                sender ꤵƤ.
  //        NO    sender  NULL , ǡѥåϿ buffer_list 
  //                ¸ߤʤ.
  // </pre>
  // </japanese>
  virtual Boolean Are_you_ready(void)
		{ return ((Sender_port::Are_you_ready() == YES)
					&& (buffer_list != NULL)) ? YES : NO; }

  //////////////////////////////////////////////////////////////////////
  // Transer the calculatio request to the owner
  //
  // <japanese>
  // üҤνͭԤ˷׻롣
  // </japanese>
  void Creq(void) { ((Element*)owner)->Creq(); }

//;	2.	ǡѥåμϿǽ, ǽ, õǽ.
public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǡѥåμϿ
  //
  // ǿμϿǡѥå, d_pack ΥǡϿӤ, d_pack
  //  d_pack  buffer_list ˼Ͽޤ.
  //
  // Ʊξ, d_pack Ť, d_pack Ͽޤ.
  //
  // ۴ؿʤΤ, 㤨Ϣ³ȽǤפʾʤɤ, 饹
  // Ʋ.
  //
  // <pre>
  //    ARGUMENT:
  //        d_pack    ǡѥåؤΥݥ󥿤 void* ˥
  //                    Ȥ.
  //    EXIT:
  //        Level 5   buffer_list εΰ褬ݤǤʤ.
  //                    (List::Put_tail)
  //    ACCIDENT:
  //        buffer_list  NULL ξ.
  //        d_pack  Data_pack* ѿǼƤʤ.
  // </pre>
  // </japanese>
  virtual void Stock(void* d_pack);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // dstr ˳Ǽ줿ǡʸ󤫤ǡѥå, Ͽ.
  // </japanese>
  virtual void Send_by_string(char*& dstr) = NULL;

public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǡݥѥåκ
  //
  // 쥯饹 Sender_port ν貾۴ؿǤ.
  // data_pack_array پõ, ƤӺޤ.
  // data_pack_array Ƥ buffer_list ˹碌ƹޤ.
  //
  // data_pack_array , ̤ΤȤ NULL ؤ褦ˤƤޤ.
  //
  // <pre>
  //   EXIT:
  //      Level 5   List::List_to_array  dat_pack_array εΰ
  //                 ݤǤʤä.
  // </pre>
  // </japanese>
  virtual void Set_data_pack_array(void)
		{ delete [] data_pack_array;
		  buffer_list->Make_array(data_pack_array, number_of_data_packs); }

public:
  //////////////////////////////////////////////////////////////////////
  virtual time_t Oldest_data_time(void);
  //////////////////////////////////////////////////////////////////////
  virtual time_t Newest_data_time(void);
  //////////////////////////////////////////////////////////////////////
  virtual int Number_of_data_packs(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǡϿ֤γǧ
  // 쥯饹 Sender_port ν貾۴ؿǤ. Υ饹 Send_port 
  // ޤ
  //
  // t_from  t_to ʹߤޤǤΥǡѥå, ϿƤ
  //  YES ֤, ϿƤʤ NO ֤ޤ.
  //
  // ޤ, data_pack_array ˼ϿƤ YES ֤ޤ.
  // ϿƤʤ,  buffer_list ˼ϿƤ뤫Ĵ,
  // buffer_list ˼ϿƤ, data_pack_array 򹹿 YES 
  // ֤ޤ.
  // ϿƤʤ NO ֤ޤ.
  //
  // <pre>
  //    ARGUMENT:
  //      t_from    t_from ǡѥåϿƤ뤳Ȥ
  //                  ǧ.
  //      t_to      t_to ʹߤޤǥǡѥåϿƤ뤳Ȥ
  //                  ǧ.
  //    RETURN:
  //      YES       t_from  t_to ʹߤޤǤΥǡѥåϿ
  //                  Ƥ.
  //      NO        t_from  t_to ʹߤޤǤΥǡѥåϿ
  //                  Ƥʤ.
  // </pre>
  // </japanese>
  virtual Boolean Can_you_get_data(time_t t_from, time_t t_to);

public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǡѥå
  //
  // 쥯饹 Sender_port ν貾۴ؿǤ.
  //
  // Ȱ, ǡ data_pack_array, number_of_data_packs 
  // Ǽޤ.
  //
  // <pre>
  //    ARGUMENT:
  //        dp_array      data_pack_array Ǽ뻲Ȱ.
  //        num_of_dp     number_of_data_packs Ǽ뻲Ȱ.
  // </pre>
  // </japanese>
  virtual void Get_data_pack_array(void**& dp_array, int& num_of_dp)
		{ dp_array = data_pack_array; num_of_dp = number_of_data_packs; }

public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǡѥå
  //
  // 쥯饹 Sender_port ν貾۴ؿǤ.
  //
  // sender  NULL Ǥʤ, sender  Get_data_pack ¹Ԥޤ.
  // λ, ϤΤޤϤޤ.
  //
  // sender  NULL ξ, data_pack_array 򸡺ưʲνԤ
  // ޤ.
  //
  // former ˤ, ǡϿ郎 data_time  data_time ˺Ǥ
  // ϿǡѥåؤΥݥ󥿤, Ǽޤ.
  //
  // later ˤ, ǡϿ郎 data_time ʹߤ data_time ˺Ǥ
  // ϿǡѥåؤΥݥ󥿤, Ǽޤ.
  //
  // ǡϿ郎 data_time ǤǡѥåϿƤ
  // , former, later Ȥ⤽Ǽޤ.
  //
  // ǡѥåǤʤ, former, later  NULL
  // ꤵޤ.
  //
  // <pre>
  //    flag ϼΥ⡼ɤ򤹤뤿Υץ, ̤Ǥ.
  //        'b'       former, later ξɬ.
  //                    Ǥʤ, ξȤ NULL ꤹ.
  //        'f'       former ɬ.
  //                    later ǤʤƤ, former Τ߼.
  //        'l'       later ɬ.
  //                    former ǤʤƤ, later Τ߼.
  //        ¾    former, later ΤʤȤ.
  // </pre>
  //  flag Υǥեͤ, 'b' Ǥ.
  // ¿Τ,  later Ϥʤ, flag  f Ȥ
  // former Τ߼,  former Ϥʤ, flag  l Ȥ
  //  later Τ߼ޤ.
  //
  // <pre>
  //  ARGUMENT:
  //      former        data_time  data_time ˺ǤᤤϿǡ
  //                      ѥåؤΥݥ󥿤Ǽ뻲Ȱ.
  //      data_time     . (sec)
  //                      λ˺ǤᤤǡϿļϿ
  //                      ѥå.
  //      later         data_time ʹߤ data_time ˺ǤᤤϿǡ
  //                      ѥåؤΥݥ󥿤Ǽ뻲Ȱ.
  //      flag          ǡѥåμꤹե饰.
  //  RETURN:
  //      YES           ΥǡѥåǤ.
  //      NO            data_pack_array  NULL ξ.
  //                      ΥǡѥåǤʤ.
  // </pre>
  // </japanese>
  virtual Boolean Get_data_pack(void*& former, time_t data_time,
								  void*& later, char flag = 'b');
public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ץǡѥåξõ
  //
  // 쥯饹 Sender_port ν貾۴ؿǤ.
  //
  // Neccesary_time_from μϿǡѥå buffer_list 
  // , õ, data_pack_array, number_of_data_packs 򹹿ޤ.
  //
  // </japanese>
  virtual void Reduce_data_pack_stock(void);

  //////////////////////////////////////////////////////////////////////
  // Delete past data_pack before t_from from buffer_list and renew
  // data_pack_array and number_of_data_packs.
  virtual void Forget_data_pack_stock(time_t t_from);

  //////////////////////////////////////////////////////////////////////
  Boolean Set_protect_past_data_flag(Boolean pflag) {
		Boolean cur_flag = protect_past_data_flag;
		protect_past_data_flag = pflag;
		return cur_flag;
	}

public:
  //////////////////////////////////////////////////////////////////////
  void Clear_data_pack(void);
		/*
			Send_port::Clear_data_pack(void)	Ͽǡѥåξõ

		Clear_data_pack Ǥ, buffer_list Ͽǡѥå, 
		, data_pack_array õޤ.
		θ, data_pack_array, number_of_data_packs , NULL, -1 
		ޤ.
		*/

//;  3.  ϿǡѥåΥեؤ¸ǽ
public:
  //////////////////////////////////////////////////////////////////////
  virtual void Save_send_port_stock(FILE* fp);
		/*
		  Send_port::Save_send_port_stock(FILE* fp)

		ϿƤǡѥåեݥ fp ǻꤵե
		˽񤭹ߤޤ

		ǡϤ٤ ( ... ) Τ褦˳̤ǰϤߤޤ
		ǽΥǡ, ϿƤǡѥåθĿǡѥåθ
		ʤ, ΤȤ, ǡѥåʸѴ, ̤ǰ
		Τ񤭹ߤޤ
		*/

//;	4.	ɽǽ.
	//; Send_port Ǥ, ޤ. Sender_port εǽѤޤ.

//;	5.	󥹥ȥ饯, ǥȥ饯.
public:
  //////////////////////////////////////////////////////////////////////
  Boolean Init(char* p_name, int p_num)
		{
			return Sender_port::Init(p_name, p_num);
		}
		/*
			Send_port::Init(char*,int) (inline)		Ѵؿ

		Sender_port::Init ¹Ԥޤ.

		RETURN:
			YES	.
			NO	Ť˽줿. (Object::Init)
		EXIT:
			5		object_name εΰ褬ݤǤʤ.
					(Object::Init)
		*/
  //////////////////////////////////////////////////////////////////////
  Send_port(char* p_name, int p_num);
  //////////////////////////////////////////////////////////////////////
  Send_port(void);
  //////////////////////////////////////////////////////////////////////
  ~Send_port(void);
		/*
			Send_port::Send_port(char*,int)			󥹥ȥ饯
			Send_port::Send_port(void)				󥹥ȥ饯
			Send_port::~Send_port(void) (virtual)	ǥȥ饯

		Send_port(char*,int) , 쥯饹 Sender_port Υǥեȥ
		ȥ饯Ѥ, Send_port::Init Ѥ, Фʲ̤
		ޤ.
			class_name			: "Send_port"
			object_name			: p_name (ҡפ˥ԡ)
			object_number			: p_num
			owner					: NULL
			buffer_list			: ҡפ˳ݤ. (³)
			receiver_array		: NULL
			number_of_receivers	: -1
			data_pack_array		: NULL
			number_of_data_packs	: -1

		ǥեȥ󥹥ȥ饯, Send_port::Init ¹Ԥޤ.
		η, ʲȤʤޤ.
			object_name			: NULL
			object_number			: -1
		¾ΥФФ, Ĥ󥹥ȥ饯ƱǤ.
		ξ, Send_port::Init ѤƥФƲ.

		ǥȥ饯, ܴ쥯饹 Object  virtual Ƥޤ.
		Send_port Ǥ, data_pack_array  delete ޤ.

		ARGUMENT:
			p_name	ü̾.
			p_num		üֹ.
		EXIT:
			5			object_name εΰݤǤʤ.
						(Object::Init)
			5			buffer_list εΰݤǤʤ.
						(Sender_port::Sender_port)
		*/

};


//;	饹 Send_port Υ饤ؿ.

inline Boolean Send_port::Can_you_get_data(time_t t_from, time_t t_to)
{	//;		Send_port::Can_you_get_data(time_t,time_t) (define)

	if (number_of_data_packs <= 0) return NO;

	if ((((Data_pack*) data_pack_array[number_of_data_packs - 1])
				->Data_time() < t_to)
		|| (((Data_pack*) data_pack_array[0])->Data_time() > t_from))
		return NO;

	return YES;
}


#endif	// ! send_h

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
