/* list.cc {\documentstyle{jsrc2latex}\rhead{\sl list.cc\quad\thepage}
   \font\tenrm=cmtt10}饹 List μ
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/12/02 10:06:07 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <stdio.h>
#include <stdlib.h>

#include "common.h"		// ץˤ붦

#include "list.h"		// 饹 List 


//	饹 List Υдؿ.

void List::Put_head(void* obj)
{	//		List::Put_head(void*) (define)

	Node* buf = new Node;	// Ρɤ.
	if (buf == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "Node", YES); exit(5); }
			// <List::Put_head>
	buf->object = obj; buf->next = head;

	// ꥹƬ˥Ρɤղä.
	head = buf;
	if (number == 0) tail = buf;	// ꥹȤ "" ä.
	number++;
}


void List::Put_tail(void* obj)
{	//		List::Put_tail(void*) (define)

	Node* buf = new Node;	// Ρɤ.
	if (buf == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "Node", YES); exit(5); }
			// <List::Put_tail>
	buf->object = obj; buf->next = NULL;

	// ꥹ˥Ρɤղä.
	if (number != 0) tail->next = buf;
	else head = buf;	// ꥹȤ "" ä.
	tail = buf;
	number++;
}


void* List::Get_head(void)
{	//		List::Get_head(void) (define)

	if (number <= 0) return NULL;	// ꥹȤ "".

	// ƬΡɤִȺ.
	void* buf_obj = head->object;
	Node* buf = head; head = head->next;
	delete buf;
	if ((--number) == 0) tail = NULL;	// ꥹȤ "" ˤʤä.

	return buf_obj;
}


void* List::Get_tail(void)
{	//		List::Get_tail(void) (define)

	void* buf_obj;	// return 

	if (number <= 1) {
		if (number <= 0) return NULL;	// ꥹȤ "".

		// Ͽ֥ȿϣĤǤ.
		buf_obj = tail->object;
		delete tail; head = tail = NULL; number = 0; return buf_obj;
	}

	// Ͽ֥ȿϣİʾǤ.

	buf_obj = tail->object;

	Node* buf = head;	// tail ΣΥΡɤؤΥݥ󥿤Ǽ.
	for (int k = number - 2; k > 0; k--) buf = buf->next;

	delete tail; tail = buf; tail->next = NULL; number--;
	return buf_obj;
}


void List::Make_array(void**& array, int& size)
{	//		List::Make_array(void**&,int&) (define)

	if ((size = number) <= 0) { array = NULL; return; }	// ꥹȤ "".

	if ((array = new void*[size]) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "void*", size); exit(5); }
			// <List::Make_array>
			// For "array" (arg).

	// Ͽ֥ȤؤΥݥ󥿤˳Ǽ.
	Node* buf = head;
	for (int k = 0; k < size; k++)
		{ array[k] = buf->object; buf = buf->next; }
}


void List::Clear_node(void)
{	//		List::Clear_node(void) (define)

	for (Node* buf = head; head != NULL; buf = head)
		{ head = head->next; delete buf; }

	tail = current = NULL; number = 0;
}


void List::Clear(void)
{	//		List::Clear(void) (define)

	if (clear_function == NULL) { Clear_node(); return; }
		// Ͽ֥ȾõѴؿꤵƤʤ.

	for (Node* buf = head; head != NULL; buf = head)
		{ head = head->next; (*clear_function)(buf->object); delete buf; }

	tail = current = NULL; number = 0;
}


void List::Init(Clear_function cl_func)
{	//		List::Init(Clear_function) (define)

	if (clear_function != NULL) { Eprint(__FILE__, __LINE__); return; }
		// <List::Init>
		// Cannot initialize.
		// "clear_function" has already been set.

	if (number > 0) { Eprint(__FILE__, __LINE__); return; }
		// <List::Init>
		// Cannot initialize.
		// This object is in use.

	clear_function = cl_func;
}


List::List(Clear_function cl_func)
	:	number(0), head(NULL),
		tail(NULL),	current(NULL),
		clear_function(NULL)
{	//		List::List(Clear_function) (define)

	Init(cl_func);
}


List::List(void)
	:	number(0), head(NULL),
		tail(NULL), current(NULL), clear_function(NULL)
{	//		List::List(void) (define)
}


List::~List(void)
{	//		List::~List(void) (define)

	Clear();
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
