/*;  total.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl total.cc\quad\thepage}} */
/*;  $$Date: 2000/12/02 08:52:51 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/total.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) total.cc -- implementation of class Total_system

#include <stdio.h>
#include <time.h>       //; time_t , tm 
#include <limits.h>     //; LONG_MIN, LONG_MAX 
#include <stdlib.h>

#include "common.h"     //; ץˤ붦
#include "list.h"       //; 饹 List 
#include "f_look.h"     //; եѴؿ
#include "datapack.h"   //; 饹 Data_pack 
#include "input.h"      //; 饹 Input_port 
#include "output.h"     //; 饹 Output_port 
#include "total.h"      //; 饹 Total_system 
#include "dfopen.h"     //; definition of dataFileOpen

#ifdef _OPENMP
#include <omp.h>        //; OpenMP
#endif

//; 饹 Total_system Υдؿ. GoBeyondTerminalTime

void Total_system::Set_ohymos_option(void)
{
    int opt;

    fprintf(stdout,"\n# Key in simulation option.\n");
    fprintf(stdout,"# TimeControlOption\n");
    switch (OhymosOption::tc) {
      case OhymosOption::GoBeyondTerminalTime:
        fprintf(stdout, "#   current selection: "
            "GoBeyondTerminalTime\n");
        break;
      case OhymosOption::DoNotGoBeyondTerminalTime:
        fprintf(stdout, "#   current selection: "
            "DoNotGoBeyondTerminalTime\n");
        break;
    }
    fprintf(stdout, "#   select 1 or 2\n"
            "#   1. GoBeyondTerminalTime (Default)\n"
            "#   2. DoNotGoBeyondTerminalTime\n");
    fscanf(stdin, "%d", &opt);
    switch (opt) {
      case 1:
        OhymosOption::tc = OhymosOption::GoBeyondTerminalTime;
        break;
      case 2:
        OhymosOption::tc = OhymosOption::DoNotGoBeyondTerminalTime;
        break;
      default:
        OhymosOption::tc = OhymosOption::GoBeyondTerminalTime;
        break;
    }
}

Boolean Total_system::Input_data_time(time_t& input_from, time_t& input_to)
{   //;    Total_system::Input_data_time(time_t&,time_t&) (define)

    input_from = LONG_MIN; input_to = LONG_MAX;

    void** dp_array; int num_of_dps; time_t buf;    //; .
    for (int k = 0; k < number_of_send_ports; k++) {
        ((Input_port*) send_port_array[k])
                            ->Get_data_pack_array(dp_array, num_of_dps);
        if (num_of_dps <= 0) return NO;

        buf = ((Data_pack*) dp_array[0])->Data_time();
        input_from = (input_from > buf) ? input_from : buf;
        buf = ((Data_pack*) dp_array[num_of_dps - 1])->Data_time();
        input_to = (input_to > buf) ? input_to : buf;
    }

    return YES;
}


Boolean Total_system::Check_data_file(FILE* fp, char* f_name)
{   //;    Total_system::Check_data_file(FILE*,char*) (define)

    long current = ftell(fp);   //; ߤ fp ΰ֤򵭲.
    fseek(fp, 0, 0);            //; ݥ󥿤եƬ˰ư.

    char buffer;                //; ե뤫ΰʸ.
    int paren[2] = { 0, 0 };    //;  {}, ݳ () ο.
    int line = 1;               //; ֹǼ.

LOOP:   //; 롼 "LOOP".
    buffer = fgetc(fp);
    switch (buffer) {
        case '(':
            paren[1]++;
            goto LOOP;
        case ')':
            if ((--paren[1]) < 0)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Check_data_file(FILE*,char*)
                    // ')' is not make pair.
                    // Too many ')' exists. Or somewhere, '(' is missing.
            goto LOOP;
        case '{':
            if (paren[1] != 0)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Check_data_file(FILE*,char*)
                    // ')' is missing. Or, '{' exists at incorrect place.
            paren[0]++;
            goto LOOP;
        case '}':
            if (paren[1] != 0)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Check_data_file(FILE*,char*)
                    // ) is missing. Or, } exists at incorrect place.
            if ((--paren[0]) < 0)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Check_data_file(FILE*,char*)
                    // '}' is not make pair.
                    // Too many '}' exists. Or somewhere, '{' is missing.
            goto LOOP;
        case EOF:
            break;
        case '#':
            do { buffer = fgetc(fp);
            } while ((buffer != '\n') && (buffer != EOF));
            if (buffer == EOF) break;
            //; case '\n' .
        case '\n':
            line++;
            //; default .
        default:
            goto LOOP;
    }
//; 롼 "LOOP" ޤ.

    fseek(fp, current, 0);  //; ݥ󥿤򸵤˰֤˰ư.

    if (paren[0] != 0)  //; ̤б { } ¸ߤ.
        { Eprint(__FILE__, __LINE__); goto TROUBLE; }
            // Total_system::Check_data_file(FILE*,char*)
            // Paren '{', '}' is not make pair.

    if (paren[1] != 0)  //; ̤б ( ) ¸ߤ.
        { Eprint(__FILE__, __LINE__); goto TROUBLE; }
            // Total_system::Check_data_file(FILE*,char*)
            // Paren '(', ')' is not make pair.

    return YES;

TROUBLE:
    fprintf(stderr, "\tAt %s %d \n", f_name, line);
    Oprint(); return NO;
}

void Total_system::Deliver_data_string(char* f_name, DataFileContent content)
{   //;    Deliver_data_string(char* f_name, DataFileContent content)
    //;  (define)

    FILE* fp = fopen(f_name, "r");
    if (fp == NULL) {
        if (content == SDPDATA) {
            return;             // nothing done if the file does not exist.
        }
        Eprint_fopen(__FILE__, __LINE__, f_name, "r"); Oprint(); exit(3);
            // Total_system::Deliver_data_string(char*, DataFileContent)
            // At setting "data_string" of components.
    }

    if (Check_data_file(fp, f_name) != YES)
        { Eprint(__FILE__, __LINE__); Oprint(); fclose(fp); return; }
            // Total_system::Deliver_data_string(char*, DataFileContent)

    char current;   //; fgetc ǼʸǼ.
    int paren = 0;  //; ̤ο.
    void *elm = this, *own = this;
        //; elm ,  Element::Parameter 륪֥ȤؤΥݥ.
        //; own , elm νͭԤؤΥݥ.
        //; parameter , elm  Element::Parameter ݤΥե饰.
    char* d_str; int d_strlen;
    char** array; int o_num;
        //; Element::Parameter, Element::Get_object Ϥ d_str
        //; λؤ˺.
LOOP:   //; 롼 "LOOP".
    current = fgetc(fp);
    Pass_whites_and_comments(fp, current, '#');
    switch (current) {
        case '{':   //; own ѹ. (¦)
            paren++;
            if ((own = elm) == NULL)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    //; Total_system::Deliver_data_string(char*, DataFileContent)
                    //; 顼.
            elm = this;
            goto LOOP;
        case '}':   //; own ѹ. (ĳ¦)
            if ((--paren) < 0)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Deliver_data_string(char*, DataFileContent)
                    //; 顼.
            elm = own;
            goto LOOP;
        case '(':   //; elm  data_string Ϳ.
            if (Make_data_string(f_name, fp, current, d_str, d_strlen,
                                 '(', ')', '#', '\\') != YES)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Deliver_data_string(char*, DataFileContent)
                    //; 顼

            ((Element*) elm)->Set_data_string(d_str, d_strlen);
            //;
            //; ǡʸγǧ
            //;  printf("%s %s %d: %d: %s\n", ((Element*) elm)->Class_name(),
            //;  ((Element*) elm)->Object_name(),
            //;     ((Element*) elm)->Object_number(), d_strlen, d_str);
            //;
            switch (content) {
              case SDPDATA: //; üҥǡΥꥹȥ
                ((Element*) elm)->Element::Restore_send_port_stock();
                break;
              case INITIAL: //; 
              case PARSET:  //; ѥ᥿
                break;
            }
            ((Element*) elm)->Clear_data_string();

            goto LOOP;
        case ')':   //; եޥåȥ顼.
            { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                // Total_system::Deliver_data_string(char*, DataFileContent)
                // Not coupling of paren ')'.
        case EOF:
            break;
        default:    //; elm ѹ.
            if (Get_strings(fp, current, array, 3, '#', '\\') < 2)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Deliver_data_string(char*, DataFileContent)
                    //
            if ((*array[1] == '(') || (*array[1] == '{')
                || (*array[1] == ')') || (*array[1] == '}')
                || (*array[1] == '\0'))
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Deliver_data_string(char*, DataFileContent)
                    //
            if ((*array[2] == '(') || (*array[2] == '{')
                || (*array[2] == ')') || (*array[2] == '}')
                || (*array[2] == '\0')) o_num = 0;
            else sscanf(array[2], "%d", &o_num);
            //; elm .
            if (Compare(array[0], array[1], o_num) == YES) {
                elm = this;  own = this;
            }
            else if ((elm = ((Element*) own)->
                        Get_component(array[0], array[1], o_num)) == NULL)
                { Eprint(__FILE__, __LINE__); goto TROUBLE; }
                    // Total_system::Deliver_data_string(char*, DataFileContent)
                    //

            delete [] array[0]; delete [] array[1]; delete [] array[2];
            goto LOOP;
    }

    if (paren != 0) { Eprint(__FILE__, __LINE__); goto TROUBLE; }
        // Total_system::Deliver_data_string(char*, DataFileContent)
        //
        //

    fclose(fp);  return;

TROUBLE:
    printf("TROUBLE: ");Oprint();
    fclose(fp);
}

void Total_system::Read_parameter_file(char* f_name)
{
    FILE* fp = dataFileOpen(f_name);
    // Comment strings are removed.

    const int BUFFLEN = 256;
    char buffer[BUFFLEN];   char* pb = buffer;
    Boolean stock_p = NO;

    int iflag;
    char* s = Get_line(fp, pb, BUFFLEN, stock_p, iflag);
    if (s == NULL) return;

    char classname[81]; char objname[81];  int objnum;
    if (sscanf(s, "%s %s %d", classname, objname, &objnum) == 3) {
        if (Compare(classname, objname, objnum) == NO) {
            Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
            // unmatched element
        }
    }
    else if (sscanf(s, "%s %d", objname, &objnum) == 2)
        {
            if (Compare(objname, objnum) == NO) {
                Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
                // unmatched element
            }
        }
    else if (sscanf(s, "%s", objname) == 1)
        {
            if (Compare(objname, 0) == NO) {
                Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
                // unmatched element
            }
        }
    else {
        Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
        // illegal line
    }

    Sub_system::Parameter(fp, pb, BUFFLEN, stock_p);
}

void Total_system::Read_initial_state_file(char* f_name)
{
    FILE* fp = dataFileOpen(f_name);
    // Comment strings are removed.

    const int BUFFLEN = 256;
    char buffer[BUFFLEN];   char* pb = buffer;
    Boolean stock_p = NO;

    int iflag;
    char* s = Get_line(fp, pb, BUFFLEN, stock_p, iflag);
    if (s == NULL) return;

    char classname[81]; char objname[81];  int objnum;
    if (sscanf(s, "%s %s %d", classname, objname, &objnum) == 3) {
        if (Compare(classname, objname, objnum) == NO) {
            Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
            // unmatched element
        }
    }
    else if (sscanf(s, "%s %d", objname, &objnum) == 2)
        {
            if (Compare(objname, objnum) == NO) {
                Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
                // unmatched element
            }
        }
    else if (sscanf(s, "%s", objname) == 1)
        {
            if (Compare(objname, 0) == NO) {
                Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
                // unmatched element
            }
        }
    else {
        Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
        // illegal line
    }

    Sub_system::Initial_state(fp, pb, BUFFLEN, stock_p);
}

void Total_system::Set_initial_state(FILE* fp)
{
    int k;
    if ( (k = fscanf(fp, "%ld", &current_time)) != 1) {
        Eprint(__FILE__, __LINE__);
        // Total_system::Set_initial_state(FILE* fp)
        // cannot read current_time.
        exit(1);
    }
    Sub_system::Initial_time(current_time);
}

void Total_system::Save_terminal_state(FILE* fp)
{
    if (fp != NULL) {
        fprintf(fp, "%ld", current_time);
    }
}

void Total_system::Write_terminal_state(char* f_name)
{   //;    Total_system::Write_terminal_state(char* f_name) (define)

    FILE* fp = fopen(f_name, "w");      //; ϥե񤭹.
    if (fp == NULL) {
        Eprint_fopen(__FILE__, __LINE__, f_name, "w");
            // Total_system::Write_terminal_state(char*)
        Oprint(); return;
    }

    fprintf(fp, "# terminal state of %s \n", object_name);
    fprintf(fp, "# current_time = %ld \n# \n", current_time);
    Sub_system::Terminal_state(fp);
    fclose(fp);
}


// modified by Y.Ichikawa (Mon Nov 13 17:34:36 1995)
void Total_system::Write_send_port_stock(char* f_name)
{   //    Total_system::Write_send_port_stock(char* f_name) (define)

    FILE* fp = fopen(f_name, "w");      //; ϥե񤭹.
    if (fp == NULL) {
        Eprint_fopen(__FILE__, __LINE__, f_name, "w");
            // Output_file::Write_hedda(void)
        Oprint(); return;
    }

    fprintf(fp, "# Send_port data of %s \n", object_name);
    fprintf(fp, "# current_time = %ld \n# \n", current_time);

    //; ʬȤ send_port Υǡѥå¸롣
    Element::Save_send_port_stock(fp);

    //; ǤˤĤ, send_port Υǡѥå¸롣
    int i, k;
    if ((number_of_components > 0) ||
        (number_of_iterator_sets > 0)) {
        fprintf(fp, "{\n");
        for (k = 0; k < number_of_components; k++) {
            ((Element*) component_array[k])->Save_send_port_stock(fp);
        }
        for (i = 0; i < number_of_iterator_sets; i++) {
            for (k = 0; k < number_of_iterators[i]; k++) {
                ((Element*) iterator_array[i][k])->Save_send_port_stock(fp);
            }
        }
        fprintf(fp, "}\n");
    }

    fclose(fp);
}


// added by Yutaka ICHIKAWA (Sun Dec  1 19:53:25 1996)
Element::OperationFlag Total_system::Do_share_info(void)
{
    if (shareinfodone_p == NO) {
        if (Share_info() == NO) {
            Eprint(__FILE__, __LINE__);
                // Total_system::Do_share_info(void)
                // Cannot share info for Total_system.
            exit(1);
        }
        shareinfodone_p = YES;
    }

    Element::OperationFlag flag;
    Boolean calcany, calcall;
    int i, k;

    do {
        calcany = NO; calcall = YES;
        for (k = 0; k < number_of_components; k++) {
            flag = ((Element*) component_array[k])->Do_share_info();
            if (flag == Element::E_DONE) calcany = YES;
            if (flag == Element::E_UNDONE) calcall = NO;
        }
        for (i = 0; i < number_of_iterator_sets; i++) {
            for (k = 0; k < number_of_iterators[i]; k++) {
                flag = ((Element*) iterator_array[i][k])->Do_share_info();
                if (flag == Element::E_DONE) calcany = YES;
                if (flag == Element::E_UNDONE) calcall = NO;
            }
        }
    } while (calcany == YES);

    if (calcall == YES) return Element::E_ALREADY;

    Eprint(__FILE__, __LINE__);
    // Total_system::Do_share_info
    // Cannot complete share info
    // These object could not do Share_info.

    for (k = 0; k < number_of_components; k++) {
         if (((Element*) component_array[k])->Do_share_info()
             == Element::E_UNDONE)
             ((Element*) component_array[k])->Oprint();
    }
    for (i = 0; i < number_of_iterator_sets; i++) {
        for (k = 0; k < number_of_iterators[i]; k++) {
            if (((Element*) iterator_array[i][k])->Do_share_info()
                == Element::E_UNDONE) {
                ((Element*) iterator_array[i][k])->Oprint();
            }
        }
    }

    return Element::E_UNDONE;
}


Boolean Total_system::Initial_work(void)
{
    if (initialworkdone_p == NO) {
        if (Initial_output() == NO) {
            cerr << "Cannot do initial_output for Total_system." << endl;
            exit(1);
        }
        initialworkdone_p = YES;
    }

    Input_data();

  LOOP:
    int i, k;
    Element::OperationFlag flag;
    Boolean calcany = NO, calcall = YES;
    for (k = 0; k < number_of_components; k++) {
        flag = ((Element*) component_array[k])->Do_initial_work();
        if (flag == Element::E_DONE) calcany = YES;
        if (flag == Element::E_UNDONE) calcall = NO;
    }
    for (i = 0; i < number_of_iterator_sets; i++) {
        for (k = 0; k < number_of_iterators[i]; k++) {
            flag = ((Element*) iterator_array[i][k])->Do_initial_work();
            if (flag == Element::E_DONE) calcany = YES;
            if (flag == Element::E_UNDONE) calcall = NO;
        }
    }
    if (calcany == YES) goto LOOP;
    if (calcall == YES) {
        Initialize_target_time(); //; target_time ν
                                  //; Sub_system Ƥ
        return YES;
    }

    Eprint(__FILE__, __LINE__);
    // Total_system::Initial_work
    // Cannot complete initial work.
    // These object could not do Initial_work.

    for (k = 0; k < number_of_components; k++) {
         if (((Element*) component_array[k])->Do_initial_work()
             == Element::E_UNDONE)
             ((Element*) component_array[k])->Oprint();
    }
    for (i = 0; i < number_of_iterator_sets; i++) {
        for (k = 0; k < number_of_iterators[i]; k++) {
            if (((Element*) iterator_array[i][k])->Do_initial_work()
                == Element::E_UNDONE) {
                ((Element*) iterator_array[i][k])->Oprint();
            }
        }
    }

    return NO;
}


void Total_system::Input_data(void)
{   //;    Total_system::Input_data(void) (define)

    for (int k = 0; k < number_of_send_ports; k++)
        ((Input_port*) send_port_array[k])->Input_data();
}


void Total_system::Output_data(void)
{   //;    Total_system::Output_data(void) (define)

    for (int k = 0; k < number_of_receive_ports; k++)
        ((Output_port*) receive_port_array[k])->Output_data();
}


time_t Total_system::Calculate_time_step(void)
{   //;    Total_system::Calculate_time_step(void) (define)

    time_t t_step;

LOOP:
    fprintf(stdout,
        "\n# Key in time_step for \'total_system\'.\n"
        "# current_time = %ld : time_step = ",
        current_time);

    fscanf(stdin, "%ld", &t_step);
    if (t_step <= 0) {
        fprintf(stdout,
            "# Invalid input : time_step <= 0\n");
        goto LOOP;
    }

    return t_step;
}

Boolean Total_system::Work(void)
{   //    Total_system::Work(void) (define)

  Boolean calc, flag_all, flag_itr;
  int i, j, k; char reply[2];
  int* itrcounter = new int[number_of_iterator_sets];
  long mtti; //; medium term target time increment

LOOP:   //; 롼 "LOOP" .

  //; ߥ졼.
  time_step = Calculate_time_step();
  while (1) {
    fprintf(stdout, "# Medium_term_target_time_increment = ");
    fscanf(stdin, "%ld", &mtti);
    if (mtti > 0) break;
    fprintf(stdout,
      "# Invalid input : Medium_term_target_time_incremnt <= 0\n");
  }

  terminal_time = current_time + time_step;
  mMediumTermTargetTime = current_time;

  try { // try block starts --------------------------------------------

  WORK: // loop of medium term taget time

    calc = NO;
    for (i = 0; i < number_of_iterator_sets; i++) itrcounter[i] = 0;

    // update medium tarm taget time
    mMediumTermTargetTime += mtti;
    if (current_time > mMediumTermTargetTime) {
      if (current_time >= terminal_time) {
        goto ASK;
      }
      else {
        goto WORK;
      }
    }

    // added by Yutaka ICHIKAWA (Wed May 24 14:06:23 2006)
    double ts, te;
#ifdef _OPENMP
    ts = omp_get_wtime();
#endif

    // Components elements calculate
    do {
      flag_all = NO;

      // modified by Yutaka ICHIKAWA (Wed May 24 14:06:23 2006)

//       // component_array
//       for (k = 0; k < number_of_components; k++) {
//         if (((Element*) component_array[k])->Work() == YES) {
//           calc = flag_all = YES;  break;
//         }
//       }
//       while (++k < number_of_components)
//         ((Element*) component_array[k])->Work();

      // component_array
#pragma omp parallel for schedule(dynamic, 1)
      for (k = 0; k < number_of_components; k++) {
//         // for debugging
// #ifdef _OPENMP
//         printf("Thread: %d\n", omp_get_thread_num());
// #endif
        if (((Element*) component_array[k])->Work() == YES) {
//           calc = flag_all = YES;  break;
          calc = flag_all = YES;
        }
      }

      // iterator_array
      for (i = 0; i < number_of_iterator_sets; i++) {
        do {
          flag_itr = NO;
          for (j = 0; j < number_of_iterators[i]; j++) {
            if (((Element*) iterator_array[i][j])->
              Work() == YES) {
              calc = flag_all = flag_itr = YES;
              break;
            }
          }
          while (++j < number_of_iterators[i])
            ((Element*) iterator_array[i][j])->Work();

        } while (flag_itr == YES);

        //; i Ǥȿ׻ɸãƤ뤫
        if (Do_you_reach_target_time(i) == YES) {
          //; «Ƥ뤫
          if (Do_you_converge(i) == YES) {
            //; ޤäǡϤ
            Flush_data(i);
            //; fixed_time 򹹿
            Renew_fixed_time(i);
            //; ȿ׻ɸꤵ
            Renew_target_time(i, Calculate_iteration_step(i));
            //; itrcounter  0 ᤹
            itrcounter[i] = 0;
          }
          else {
            //; current_time 򴬤᤹
            Rewind_current_time(i);
            //; itrcounter  1 䤹
            if (++itrcounter[i] >= 1000) {
              Eprint(__FILE__, __LINE__);
              // Total_system::Work(void)
              // Iterative calculation cannot converge
              fprintf(stderr, "\tin group [%d].\n", i);
              Oprint(); exit(1);
            }
          }
        }
      }
    } while (flag_all == YES);

    // added by Yutaka ICHIKAWA (Wed May 24 14:06:23 2006)
#ifdef _OPENMP
    te = omp_get_wtime();
    printf("elapsed time: %lf\n", te-ts);
#endif

    if (calc == NO) {
      // <japanese>
      // ɤǤ٤׻Ǥʤä. ϴŪˤϵʤ
      // ͣβǽʥϡϥե뤫ɬפʥǡɤ߹ʤ
      // ȤǤ롣ʤ顢catch block ǤϤ
      // </japanese>
      fprintf(stdout, "\n# No object has worked.\n");
      goto ASK;
    }

    //; current_time ιǤǺǤ٤˹碌
    if (Renew_current_time() != YES) {
      fprintf(stderr,
        "\n# Error : Total_system::Renew_current_time(void)\n");
    }

    if (current_time < mMediumTermTargetTime) {
      // <japanese>
      // mMediumTermTargetTime ޤǽλʤä
      // ϴŪˤϵʤ
      // ͣβǽʥϡϥե뤫ɬפʥǡɤ߹ʤ
      // ȤǤ롣ʤ顢catch block ǤϤ
      // </japanese>
      fprintf(stderr,
        "\n# Error : Stopped before MediumTermTargetTime\n");
      goto ASK;
    }

    if (mMediumTermTargetTime < terminal_time) {
	  // for debug
	  cout << mMediumTermTargetTime << endl;
      goto WORK;
    }

    //; .
    Output_data();
    fprintf(stdout, "\n# Done.\n");

  } // end of try block ------------------------------------------------
  catch (int i) { // start of catch block ------------------------------

    //
    // <japanese>
    // üҤ׻׵ȤäȤˡthrow 99 ޤϡ
    //  catch  block Ǥ
    // </japanese>
    //; .
    fprintf(stderr, "\n# Error : Now in catch block\n");
    Output_data();

  } // end of catch block ----------------------------------------------

ASK:
  fprintf(stdout,
    "# Now : current_time = %ld : terminal_time = %ld\n"
    "# Quit? [Y / N] : ",
    current_time, terminal_time);
  fscanf(stdin, "%1s", reply);
  switch (reply[0]) {
  case 'y':
  case 'Y':
    fprintf(stdout, "\n# Simulation ended.\n");
    return YES;		//; ߥ졼νλ.
  case 'n':
  case 'N':
    Input_data();
    goto LOOP;		//;ߥ졼η³.
  }

  //; . 䤤碌.
  fprintf(stdout,
    "# Invalid input : Key in \'Y\' or \'N\'\n\n");
  goto ASK;
  delete [] itrcounter;

  return NO;
}

// modified by Y.Ichikawa
Total_system::Total_system(void)
    :   Sub_system(),
        terminal_time(LONG_MIN)
{   //;    Total_system::Total_system(void) (define)

    class_name = "Total_system";

//; 桼ηϥ饹Υ󥹥ȥ饯Τʤ
//; Ū Init ֤褦ѹ롣
//;  Sub_system::Init("total_system", 0);
}

Total_system::~Total_system(void)
{   //;    Total_system::~Total_system(void) (define)
}

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
